package mmaplayers.fightersearch.service;

import mmaplayers.fightersearch.dao.IFighterDao;
import mmaplayers.fightersearch.model.Fighter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

public class FighterService implements IFightService{

	  @Autowired
	    IFighterDao iFighterDao;

	    @Autowired
	    IFighterQueryService queryService;


	    @Override
	    public Collection<String> findAllCategories() {
	        List<String> result = null;

	        result = iFighterDao.findAll()
	                .stream()
	                .map(book -> book.getCategorie())
	                .distinct()
	                .sorted()
	                .collect(Collectors.toList());

	        return result;
	    }

	    @Override
	    public Collection<Fighter> findByAnyCategorie(String... categories) {
	        return queryService.anyCategorie(categories).exec();
	    }

	    @Override
	    public Collection<Fighter> findByAllCategories(String... categories) {
	        return queryService.allCategories(categories).exec();
	    }

	    @Override
	    public Collection<Fighter> findByNameContains(String name) {
	        return queryService.anyName(name).exec();
	    }

	    @Override
	    public Collection<Fighter> findAll() {
	        return iFighterDao.findAll();
	    }
}
